# frozen_string_literal: true

module Ruboty
  module Handlers
    class VirtualNameCard < Base
      on(
        /背景画像 (?<name_kanji>.+),(?<name_romaji>.+),(?<role>.*),(?<email>.*),(?<twitter_account>.*),(?<url>.*)\z/,
        name: "generate_virtual_name_card",
        description: "Generate virtual name card",
      )

      def generate_virtual_name_card(message)
        virtual_name_card_image = ::VirtualNameCard::Generator.build(
          name_kanji: message[:name_kanji],
          name_romaji: message[:name_romaji],
          role: message[:role] == "" ? nil : message[:role],
          email: message[:email] == "" ? nil : message[:email],
          twitter_account: message[:twitter_account] == "" ? nil : message[:twitter_account],
          url: message[:url] == "" ? nil : message[:url],
        )

        message.reply(
          "できました！",
          file: {
            path: virtual_name_card_image.mini_magick_image.path,
            title: message[:name_romaji],
            content_type: "image/jpeg" # TODO: Change for virtual name card image
          }
        )
      end
    end
  end
end
